'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (container) {
  var config = container.get('config');
  var logger = container.get('logger');
  var workDir = config.workDir;
  var storageDir = workDir + config.storage.directory;
  var authDir = workDir + '/db';
  var foldersToCheck = [storageDir, storageDir, authDir];
  var filesToCheck = [authDir + '/user_tokens.json'];
  if (config.auth.adapter === "/auth/json-db") {
    filesToCheck.push(authDir + '/user_db.json');
  }

  for (var i = 0; i < foldersToCheck.length; i++) {
    var folder = foldersToCheck[i];
    if (!_fs2.default.existsSync(folder)) {
      try {
        _fs2.default.mkdirSync(folder, '0777');
      } catch (err) {
        logger.error("Could not create folder: " + folder);
        logger.error(err);
      }
    }
  }

  for (var _i = 0; _i < filesToCheck.length; _i++) {
    var file = filesToCheck[_i];
    if (!_fs2.default.existsSync(file)) {
      try {
        _fs2.default.writeFileSync(file, JSON.stringify({}), { options: { encoding: 'utf8', mode: '0777' } });
      } catch (err) {
        logger.log("Could not create file: " + file);
        logger.log(err);
        logger.log('\n');
      }
    }
  }
};

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }