"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(storage, proxy, proxyEnabled) {
    _classCallCheck(this, _class);

    this.storage = storage;
    this.proxy = proxy;
    this.proxyEnabled = proxyEnabled;
  }

  /*
   * Reads the package.json data from filesystem and sends it to the npm-client
   * */


  _createClass(_class, [{
    key: "process",
    value: function process(httpRequest, httpResponse) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        return _this.storage.getPackageData({
          name: httpRequest.body._packageName,
          scope: httpRequest.body._scope,
          unscoped: httpRequest.body._scopedName
        }).catch(function (err) {
          if (_this.proxyEnabled) {
            _this.proxy.process(httpRequest, httpResponse).then(resolve());
          } else {
            console.log("Err: Proxy disabled, rejecting: " + httpRequest.body._packageName);
            reject(err);
          }
        }).then(function (packageJson) {
          if ((typeof packageJson === "undefined" ? "undefined" : _typeof(packageJson)) === 'object') {
            httpResponse.send(packageJson);
            resolve();
          } else {
            reject("package not found");
          }
        });
      }).catch(function (err) {
        console.log("Err: 404, " + err);
        httpResponse.status(404);
        httpResponse.send(err);
      });
    }
  }]);

  return _class;
}();

exports.default = _class;